// SNESpad class
// Version 1.0
// Kerry High

#ifndef __SNESPAD_H
#define __SNESPAD_H

class SNESpad
{
public:
   // New snespad, base=LPT1
   SNESpad();
   // New snespad, set base by lpt#
   SNESpad(int lpt_number);
   // Set base by lpt#: 1=0x378 2=0x278 3=0x3BC
   void setlpt(int lpt_number);
   // Set to any base
   void setbase(int port_number);
   // Read pad number pad_number
   // Pads are numbered from 0 to 4
   void readpad(int pad_number);
   // Return 1 if button pressed at last read, 0 otherwise
   int up();
   int down();
   int left();
   int right();
   int a();
   int b();
   int x();
   int y();
   int select();
   int start();
   int l();
   int r();
private:
   unsigned int base;
   struct
   {
      int up, down, left, right, a, b, x, y, select, start, l, r;
   } snes;
};

#endif
