// SNES Pad tester

#include <iostream.h>
#include <conio.h>
#include "snespad.h"

int main()
{
   int pad_no, lpt_no, done=0;
   cout << "What LPT port (1-3) is the SNES pad attached to? ";
   cin >> lpt_no;
   while ((lpt_no<1)||lpt_no>3)
   {
      cout << "Must be from 1-3, try again: ";
      cin >> lpt_no;
   }
   cout << "Which pad on that port (1-5) do you wish to test? ";
   cin >> pad_no;
   while ((pad_no<1)||pad_no>5)
   {
      cout << "Must be from 1-5, try again: ";
      cin >> pad_no;
   }
   pad_no--; // Pads are numbered 0-4
   SNESpad mypad(lpt_no);
   clrscr();
   textmode(C40);
   _setcursortype(_NOCURSOR);
   textcolor(RED);
   cprintf(" SNES Pad Tester  I\r\n");
   cprintf(" By Kerry High    I\r\n");
   cprintf("                  I\r\n");
   cprintf("      /-----------I-------------\\\r\n");
   cprintf("     / [  L  ]    I     [  R  ]  \\\r\n");
   cprintf("    /--------------------------\\  \\\r\n");
   cprintf("   /                            \\  \\\r\n");
   cprintf("  /           Nintendo           \\  \\\r\n");
   cprintf(" /                                \\  \\\r\n");
   cprintf("/     ^                      X     \\ |\r\n");
   cprintf("|     *                     *      | |\r\n");
   cprintf("|     *                    *       | |\r\n");
   cprintf("|  <*****>     **     **  Y     A  | |\r\n");
   cprintf("|     *      **     **         *   | |\r\n");
   cprintf("|     *     Select Start      *    | |\r\n");
   cprintf("\\     v                      B    / /\r\n");
   cprintf(" \\                               / /\r\n");
   cprintf("  \\       /-------------\\       / /\r\n");
   cprintf("   \\     /               \\     //\r\n");
   cprintf("    \\---/                 \\---/\r\n");
   textcolor(LIGHTGRAY);
   cprintf("\r\n\r\n           Pad #%d on LPT%d\r\n\r\n",pad_no+1,lpt_no);
   cprintf("      Press ESC to end program");
   while (!done)
   {
      if (kbhit())
         if (getch()==27)
            done=1;
      mypad.readpad(pad_no);
      if (mypad.l()) textcolor(YELLOW); else textcolor(BLUE);
      gotoxy(11,5);
      cprintf("L");
      if (mypad.r()) textcolor(YELLOW); else textcolor(BLUE);
      gotoxy(28,5);
      cprintf("R");
      if (mypad.up()) textcolor(YELLOW); else textcolor(BLUE);
      gotoxy(7,10);
      cprintf("^");
      if (mypad.down()) textcolor(YELLOW); else textcolor(BLUE);
      gotoxy(7,16);
      cprintf("v");
      if (mypad.left()) textcolor(YELLOW); else textcolor(BLUE);
      gotoxy(4,13);
      cprintf("<");
      if (mypad.right()) textcolor(YELLOW); else textcolor(BLUE);
      gotoxy(10,13);
      cprintf(">");
      if (mypad.select()) textcolor(YELLOW); else textcolor(BLUE);
      gotoxy(13,15);
      cprintf("Select");
      if (mypad.start()) textcolor(YELLOW); else textcolor(BLUE);
      gotoxy(20,15);
      cprintf("Start");
      if (mypad.x()) textcolor(YELLOW); else textcolor(BLUE);
      gotoxy(30,10);
      cprintf("X");
      if (mypad.y()) textcolor(YELLOW); else textcolor(BLUE);
      gotoxy(27,13);
      cprintf("Y");
      if (mypad.a()) textcolor(YELLOW); else textcolor(BLUE);
      gotoxy(33,13);
      cprintf("A");
      if (mypad.b()) textcolor(YELLOW); else textcolor(BLUE);
      gotoxy(30,16);
      cprintf("B");
   }
   textmode(C80);
   return 0;
}
